//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <memory>
#include "bufferlistform.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
__fastcall TBufferListFrm::TBufferListFrm(TComponent* Owner )
        : TForm(Owner),
          ColumnToSort(0),
          Direction(true)
{
  ResultImageList->Clear();
  ResultImageList->AddImages( PointsImageList ); 
}
//---------------------------------------------------------------------------
void __fastcall TBufferListFrm::Clear()
{
  ListView->Items->BeginUpdate();
  ListView->Items->Clear();
  ListView->Items->EndUpdate();
}
//---------------------------------------------------------------------------
void __fastcall TBufferListFrm::BufferListBoxDblClick(TObject *Sender)
{
  if ( ListView->Selected )
    ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TBufferListFrm::AddBuffer( AnsiString BufferName )
{
  TListItem *Item = ListView->Items->Add();

  Item->Caption = ExtractFileName(BufferName);
  AnsiString Ext = ExtractFileExt( BufferName );
  if ( Ext.Pos(".") == 1 )
    Ext = Ext.SubString ( 2, 1000 ).UpperCase();
  Item->SubItems->Add ( Ext );
  Item->SubItems->Add ( ExtractFileDir(BufferName) );

  if( FileExists( BufferName ))
    {
    TSHFileInfo SHFileInfo;
    SmallImages->ShareImages = true;

    SmallImages->Handle = SHGetFileInfo(BufferName.c_str(), 0, &SHFileInfo,
            sizeof(SHFileInfo), SHGFI_SMALLICON|SHGFI_SYSICONINDEX);

    SHGetFileInfo( BufferName.c_str(), 0, &SHFileInfo,
            sizeof(SHFileInfo),
            SHGFI_SYSICONINDEX );

    Graphics::TIcon* Image = new Graphics::TIcon;
    SmallImages->GetIcon( SHFileInfo.iIcon, Image );
//    ShowMessage( IntToStr( Image->Height ));
    ResultImageList->AddIcon( Image );
    delete Image;

    Item->ImageIndex = ResultImageList->Count - 1;
    }

  else
    Item->ImageIndex = 2;

  Item->Data = (void *)Item->Index;

  if ( ! ListView->Selected )
    {
    Item->ImageIndex = 3;
    ListView->Selected = Item;
    ListView->ItemFocused = Item;
    }
}
//---------------------------------------------------------------------------
int  __fastcall TBufferListFrm::GetSelectedIndex()
{
  if ( ListView->Selected )
    return (int)ListView->Selected->Data;

  return 0;
}
//---------------------------------------------------------------------------
void __fastcall TBufferListFrm::ListViewColumnClick(TObject *Sender,
      TListColumn *Column)
{
  ListView->Columns->Items [ ColumnToSort ]->ImageIndex = -1;

  if ( ColumnToSort == Column->Index )
    Direction = ! Direction;

  else
    {
    Direction = true;
    ColumnToSort = Column->Index;
    }

  ListView->AlphaSort();

  ListView->Columns->Items [ ColumnToSort]->ImageIndex = (Direction) ? 0 : 1;
}
//---------------------------------------------------------------------------
void __fastcall TBufferListFrm::ListViewCompare(TObject *Sender,
      TListItem *Item1, TListItem *Item2, int Data, int &Compare)
{

  int DirMultiply = (( Direction ) ? 1 : -1 );

  if (ColumnToSort == 0)
    Compare = DirMultiply * CompareText ( Item1->Caption, Item2->Caption );

  else
    {
    int ix = ColumnToSort - 1;
    Compare = DirMultiply * CompareText ( Item1->SubItems->Strings[ix], Item2->SubItems->Strings[ix] );
    }

}
//---------------------------------------------------------------------------
void __fastcall TBufferListFrm::FormShow(TObject *Sender)
{
  ProgramDir = ExtractFilePath(Application->ExeName);
  if(ProgramDir[ProgramDir.Length()] != '\\')
    ProgramDir += "\\";

  String File = ProgramDir + "BufferListSizes.dtt";
  if(FileExists(File))
    {
    std::auto_ptr<TMemoryStream> Strm(new TMemoryStream());
    try
      {
      Strm->LoadFromFile(File);
      Strm->Read(&Values, sizeof(Values));

      BoundsRect = Values.BoundsRect;

      int C = ListView->Columns->Count;
      for(int i = 0; i < C; ++i)
        ListView->Columns->Items[i]->Width = Values.ColumnSizes[i];
      }
    catch(...)
      {
      }
    }

  else
    {
    SetBounds((Screen->Width - Width) / 2,
                (Screen->Height - Height) / 2,
                Width, Height);
    }

  ListView->AlphaSort();
  ListView->Columns->Items [ ColumnToSort ]->ImageIndex = (Direction) ? 0 : 1;
  if ( ListView->Selected )
    ListView->Selected->MakeVisible( false );

  ActiveControl = ListView;
}
//---------------------------------------------------------------------------
void __fastcall TBufferListFrm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  Values.BoundsRect = BoundsRect;

  int C = ListView->Columns->Count;
  for(int i = 0; i < C; ++i)
    Values.ColumnSizes[i] = ListView->Columns->Items[i]->Width;

  std::auto_ptr<TMemoryStream> Strm(new TMemoryStream());

  Strm->Write(&Values, sizeof(Values));

  try
    {
    Strm->SaveToFile(ProgramDir + "BufferListSizes.dtt");
    }
  catch(...)
    {
    }
}
//---------------------------------------------------------------------------

